Name     : hp-netxtreme2
Version  : 6.2.23
Release  : 2
Group    : System Environment/Base
Vendor   : Broadcom Corporation
URL	 : http://www.broadcom.com
License  : GPL
Source0  : %{name}-%{version}.tar.gz
Source1  : kmptool.sh
Source2  : distros.dat
Source3  : hp_bcm_preamble
Source10 : find-requires.ksyms
Source11 : symbols.greylist
BuildRoot: %{_tmppath}/%{name}-buildroot
Summary  : HP NC-Series Broadcom 1/10 GbE Multifunction and iSCSI Drivers for Linux

%define packinfo "This package contains the Broadcom NetXtreme II iSCSI (bnx2i), 1-Gigabit (bnx2), and 10-Gigabit (bnx2x) ethernet drivers."
%define docsinfo "Documentation for the Broadcom NetXtreme II iSCSI, 1-Gigabit, and 10-Gigabit ethernet drivers for HP ProLiant systems."
%define debug_package %{nil}

%define getkvers bash %_sourcedir/kmptool.sh kvers
%define getldist bash %_sourcedir/kmptool.sh ldist
%define distros  cat  %_sourcedir/distros.dat
%define lnxdist %(%{getldist})
%define kverrel %(%{distros} | %{getkvers})

%define __find_requires %_sourcedir/find-requires.ksyms

%if "%{lnxdist}" == "rhel6sp0"
%define _host_vendor redhat
%endif

%if "%{_host_vendor}" == "suse"
%if %{!?KVER:1}%{?KVER:0}
%ifarch x86_64
%define flav debug default kdump smp xen trace
%else
%define flav bigsmp debug default kdump kdumpae smp vmi vmipae xen xenpae pae trace
%endif
%endif
%if %{!?KVER:0}%{?KVER:1}
%define flav %(echo %{KVER} | awk -F"-" '{print $3}')
%define kverrel %(echo %{KVER} | awk -F"-" '{print $1"-"$2}')
%endif
%endif

%if "%{_host_vendor}" == "redhat"
%if %{!?KVER:1}%{?KVER:0}
%define flav ""
%endif
%if %{!?KVER:0}%{?KVER:1}
%define flav %(echo %{KVER} | awk -F"el5" '{print $2}')
%define kverrel %(echo %{KVER} | sed -e 's/\([0-9]\.[0-9]\.[0-9]*\-[0-9]*\.[Ee][Ll][5-6]*\).*/\1/')
%if "%{flav}" == ""
%define flav default
%endif
%endif
%endif

%if "%{_host_vendor}" == "suse"
BuildRequires: kernel-source kernel-syms
%define kernel_source /usr/src/linux-obj/%{_target_cpu}
%{suse_kernel_module_package -x %flav -p %_sourcedir/hp_bcm_preamble}
%else
BuildRequires: %kernel_module_package_buildreqs
%if "%{lnxdist}" == "rhel6sp0"
%{kernel_module_package default -p %_sourcedir/hp_bcm_preamble}
%else
%{kernel_module_package %flav -p %_sourcedir/hp_bcm_preamble}
%endif
%endif

%description
%{packinfo}

%package KMP
Summary: HP NC-Series Broadcom 1/10 GbE Multifunction and iSCSI Drivers for Linux
Group: System/Kernel

%description KMP
%{packinfo}

%package doc
Summary: Documentation for the Broadcom NetXtreme II iSCSI, 1-Gigabit, and 10-Gigabit ethernet drivers 
Group: System/Kernel

%description doc
%{docsinfo}

%prep
%setup 
set -- *
mkdir source
mv "$@" source/
cp -f source/bnx2/README.TXT source/README.bnx2.TXT
cp -f source/bnx2x/README.TXT source/README.bnx2x.TXT
cp -f source/bnx2/RELEASE.TXT source/RELEASE.bnx2.TXT
cp -f source/bnx2x/RELEASE.TXT source/RELEASE.bnx2x.TXT
cp -f source/bnx2i/docs/README.TXT source/README.bnx2i.TXT
cp -f source/bnx2i/docs/RELEASE.TXT source/RELEASE.bnx2i.TXT
mkdir obj

%build
export KVER=%{kverrel}
export KABIRPM=1
export EXTRA_CFLAGS='-DVERSION=\"%version\"'

%if %{!?KVER:0}%{?KVER:1}
%define flavors %{flav}
%else
%define flavors %{flavors_to_build}
%endif

for flavor in %{flavors}; do
  rm -rf obj/$flavor
  cp -r source obj/$flavor
  export LINUXSRC=%{kernel_source $flavor}
  if [ "%{_host_vendor}" == "redhat" ]; then
    if [ $flavor == "default" ]; then
      kernel_flavor=${KVER}
    else
      kernel_flavor=${KVER}${flavor}
    fi
  elif [ "%{_host_vendor}" == "suse" ]; then
    kernel_flavor=${KVER}-${flavor}
  fi
  make -C obj/$flavor KVER=$kernel_flavor
done

%install
export KVER=%{kverrel}
export KABIRPM=1
export EXTRA_CFLAGS='-DVERSION=\"%version\"'

%if %{!?KVER:0}%{?KVER:1}
%define flavors %{flav}
%else
%define flavors %{flavors_to_build}
%endif

for flavor in %{flavors}; do
  export LINUXSRC=%{kernel_source $flavor}
  if [ "%{_host_vendor}" == "redhat" ]; then
    if [ $flavor == "default" ]; then
      kernel_flavor=${KVER}
    else
      kernel_flavor=${KVER}${flavor}
    fi
    dest_dir=${RPM_BUILD_ROOT}/lib/modules/$kernel_flavor/extra/%{name}
  elif [ "%{_host_vendor}" == "suse" ]; then
    kernel_flavor=${KVER}-${flavor}
    dest_dir=${RPM_BUILD_ROOT}/lib/modules/$kernel_flavor/updates/%{name}
  fi
  mkdir -p $dest_dir
  install -m 444 obj/${flavor}/bnx2/src/bnx2.ko $dest_dir
  install -m 444 obj/${flavor}/bnx2x/src/bnx2x.ko $dest_dir
  if [ "%{lnxdist}" == "sles11sp1" ] || \
     [ "%{lnxdist}" == "rhel6sp0" ] || \
     [ "%{lnxdist}" == "rhel5sp5" ] || \
     [ "%{lnxdist}" == "rhel5sp4" ]; then
    install -m 444 obj/${flavor}/bnx2/src/cnic.ko $dest_dir
    install -m 444 obj/${flavor}/bnx2i/driver/bnx2i.ko $dest_dir
  fi
done

man_dir=${RPM_BUILD_ROOT}/usr/share/man/man4
mkdir -p ${man_dir}
gzip -c source/bnx2/src/bnx2.4 > ${man_dir}/bnx2.4.gz
gzip -c source/bnx2x/src/bnx2x.4 > ${man_dir}/bnx2x.4.gz

%clean
rm -rf %{buildroot}

%files doc
%defattr(-, root, root)
%doc source/INSTALL.TXT 
%doc source/README.bnx2.TXT 
%doc source/RELEASE.bnx2.TXT 
%doc source/README.bnx2x.TXT 
%doc source/RELEASE.bnx2x.TXT 
%_mandir/man4/bnx2.4.gz
%_mandir/man4/bnx2x.4.gz
%if "%{lnxdist}" == "sles11sp1" || "%{lnxdist}" == "rhel5sp5" || "%{lnxdist}" == "rhel5sp4" || "%{lnxdist}" == "rhel6sp0"
%doc source/README.bnx2i.TXT 
%doc source/RELEASE.bnx2i.TXT 
%endif

%define major_change (Severity:Critical)
%define medium_change (Severity:Medium)
%define minor_change (Severity:Minor)

%changelog
